from utils import *


def analyze_dataset():
    files = glob.glob('../data/splits/*/*.json')

    n_utterances = []
    n_sentences = []
    n_words = []
    label_set = set()
    for file in files:
        doc = load_json(file)
        ann = doc['annotation']
        ann = [x for x in ann if len(x['text']) > 0]
        n_utterances.append(len(ann))
        # try:
        for utter in ann:
            sentences = utter['text']
            n_sentences.append(len(sentences))
            for sent in sentences:
                n_words.append(len(sent.split(' ')))
            label_set.update(utter['utterance_label'])

    print('#Utterance', min(n_utterances), max(n_utterances))
    print('#Sentence/U', min(n_sentences), max(n_sentences))
    print('#Word/S', min(n_words), max(n_words), sum(n_words)/len(n_words))
    print('Label set', sorted(label_set))


if __name__ == '__main__':
    analyze_dataset()
