import glob
from collections import OrderedDict

LABEL_SET = ['BCS', 'ELC', 'ELD', 'ELR', 'EVL', 'EXA', 'PVD', 'PVR', 'STC', 'AVG']


def extract_a_file(path):
    with open(path) as f:
        lines = f.read().splitlines()

    devs, tests = [], []
    lr, bs, utter, lm = '-', '-', '-', '-'
    for i, line in enumerate(lines):
        if line.startswith('lr:'):
            lr = line.split('\t')[1]
        if line.startswith('batch_size:'):
            bs = line.split('\t')[1]
        if line.startswith('utterance:'):
            utter = line.split('\t')[1]
        if line.startswith('lm:'):
            lm = line.split('\t')[1]
        if line.startswith('Evaluate '):
            epoch = line.split()[3]
            for l in lines[i + 1:i + 11]:
                label, p, r, f = l.split()
                if label == 'AVG':
                    perf = [epoch, float(p), float(r), float(f)]
            if line.startswith('Evaluate Dev'):
                devs.append(perf)
            elif line.startswith('Evaluate Test'):
                tests.append(perf)

    if len(devs) > 0 and len(tests) > 0:
        # Best on devs
        sorted_devs = sorted(devs, key=lambda x: x[-1], reverse=True)
        best = sorted_devs[0]
        print(file)
        epoch = int(best[0])
        try:
            res = best + tests[epoch] + [lr, bs, utter, lm, file]
            return res
        except:
            pass

        # # Best on tests
        # soted_tests = sorted(tests, key=lambda x: x[-1], reverse=True)
        # best = soted_tests[0]
        # epoch = int(best[0])
        # try:
        #     print(devs[epoch], best)
        # except:
        #     pass




if __name__ == '__main__':
    files = []
    # files = glob.glob('base/*/log.txt')
    files += glob.glob('trans/*/log.txt')
    # files += glob.glob('gcncnn/*/log.txt')
    # files += glob.glob('cnnlstm/*/log.txt')
    # files += glob.glob('gcnlstm/*/log.txt')
    # files += glob.glob('gcncnnlstm/*/log.txt')
    files = [x for x in files if 'ut-48' not in x]
    res = []
    for file in files:
        res.append(extract_a_file(file))

    res = [x for x in res if x]
    # res = [x for x in res if x and x[7] > 50.]

    res = sorted(res, key=lambda x: x[7], reverse=True)
    for x in res:
        print('{}\t{:5.1f}\t{:5.1f}\t{:5.1f}\t'.format(*x[:4]) +
              '{}\t{:5.1f}\t{:5.1f}\t{:5.1f}\t'.format(*x[4:8]) +
              '{}\t{}\t{}\t{}\t{}'.format(*x[8:13]))
