import json
import logging
import argparse
import tqdm
import os
import torch
from torch.nn import *
from torch.utils.data import Dataset, DataLoader
from torch.optim import Adam, SGD, AdamW, Adadelta
import glob
from transformers import AutoTokenizer, AutoModel
from datetime import datetime
from sklearn.metrics import *
from collections import OrderedDict, defaultdict, Counter


def load_json(path, log=True):
    if log:
        print('- Loading: ', path)
    with open(path, 'r') as f:
        data = json.load(f)
    return data


def save_json(data, path, log=True):
    if log:
        print('- Saving: ', path)
    with open(path, 'w') as f:
        json.dump(data, f)
    return data
