import glob
import os
from collections import *

def none():
    return None


def read(path):
    with open(path) as f:
        text = f.read()
    return text


def compare_all():
    split_files = glob.glob('data/splits/*/*.json')
    print('Split files', len(split_files))

    annotated_files = glob.glob('../static/data/*/*/*.json')
    print('annotated_files', len(annotated_files))
    m = defaultdict(none)
    for file in annotated_files:
        data = read(file)
        m[data] = file

    for file in split_files:
        data = read(file)

        if data in m:
            split = file.split('/')[2]
            name = file.split('/')[-1]
            _,_,_,week,annotator,name2 = m[data].split('/')
            assert name == name2
            is_curation = 'curation' in week
            print(f'{file} {split} {name} <- {m[data]} {week} {is_curation} {annotator} {name2}')


if __name__ == '__main__':
    compare_all()